using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.ServiceModel;
using System.Text;
using ICS.WCF.Base;
using UFSoft.UBF.Exceptions1;
using UFSoft.UBF.Service;
using UFSoft.UBF.Util.Context;
using UFSoft.UBF.Exceptions;
using www.ufida.org.EntityData;

namespace UFIDA.ISV.BFTransferFormApprove
{
    public class CustBFTransFromApprove
    {

        public static ReturnValue1 CustApproveRec(string DocCode,string OrgID)
        {
            long DocID = 0;
            string EntityType = "";
            #region 服务调用框架结构
            //实例化代理类 
            UFIDAU9ISVTransferFormISVICommonApprovedTransferFormSRVClient client = new UFIDAU9ISVTransferFormISVICommonApprovedTransferFormSRVClient();
            //服务返回结果
            //UFIDAU9PMPOPurchaseOrderData[] returnItems;
            //返回异常信息，目前还没有使用此属性
            UFSoft.UBF.Exceptions1.MessageBase[] returnMsg;
            //上下文信息
            object context;
            //传入 参数
            UFIDAU9CBOPubControllerCommonArchiveDataDTOData[] pOList;
            try
            {
                int acttype = int.Parse(ConfigurationManager.AppSettings["acttype"].ToString());
                List<UFIDAU9CBOPubControllerCommonArchiveDataDTOData> transferInfoList = new List<UFIDAU9CBOPubControllerCommonArchiveDataDTOData>();
                UFIDAU9CBOPubControllerCommonArchiveDataDTOData transferinfo = new UFIDAU9CBOPubControllerCommonArchiveDataDTOData();
                //给上下文信息赋值
                context = CreateContextObj(OrgID);
                //给传入参数赋值
                transferinfo.m_code = DocCode;
                transferInfoList.Add(transferinfo);
                pOList = transferInfoList.ToArray();

                //pOList = SetPoDtos(U9Info, poInfoList);
                //服务调用
                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;

                returnMsg = client.Do(context, pOList);
                if (returnMsg != null)
                {
                    ReturnValue1 value = new ReturnValue1();
                    value.IsSuccess = false;
                    value.Mes = returnMsg[0].localMessage;
                    return value;
                }
                else
                {
                    ReturnValue1 value = new ReturnValue1();
                    //异常信息捕获
                    value.poheadList = returnMsg;
                    //value.Mes = "未返回任何数据";
                    value.IsSuccess = true;

                    StringBuilder str = new StringBuilder();
                    str.AppendLine("审核形态转换单");
                    str.AppendLine("单号:" + DocCode);
                    str.AppendLine("结果:" + "True");
                    Appconfig.WriteLogFile(str.ToString(), "审核形态转换单");

                    return value;
                }
            }
            catch (Exception ex)
            {
                StringBuilder str = new StringBuilder();
                str.AppendLine("审核形态转换单");
                str.AppendLine("单号:" + DocCode);
                str.AppendLine("错误:" + GetExceptionMessage(ex));
                str.AppendLine("结果:" + "False");
                Appconfig.WriteLogFile(str.ToString(), "审核形态转换单");
                ReturnValue1 value = new ReturnValue1();
                //异常信息捕获
                value.Mes = GetExceptionMessage(ex);
                value.IsSuccess = false;
                return value;
            }
            #endregion
        }

        #region 提取异常信息
        /// <summary>
        /// 提取异常信息
        /// </summary>
        /// <param name="ex"></param>
        private static string GetExceptionMessage(Exception ex)
        {
            string faultMessage = "未知错误，请查看ERP日志！";

            System.TimeoutException timeoutEx = ex as System.TimeoutException;
            if (timeoutEx != null)
            {
                faultMessage = "访问服务超时，请修改配置信息！";
            }
            else
            {
                FaultException<ServiceException> faultEx = ex as FaultException<ServiceException>;
                if (faultEx == null)
                {
                    faultMessage = ex.Message;
                }
                else
                {
                    ServiceException serviceEx = faultEx.Detail;
                    if (serviceEx != null && !string.IsNullOrEmpty(serviceEx.Message)
                        && !serviceEx.Message.Equals("fault", StringComparison.OrdinalIgnoreCase))
                    {
                        // 错误信息在faultEx.Message中，请提取，
                        // 格式为"Fault:料品不能为空，请录入\n 在....."
                        int startIndex = serviceEx.Message.IndexOf(":");
                        int endIndex = serviceEx.Message.IndexOf("\n");
                        if (endIndex == -1)
                            endIndex = serviceEx.Message.Length;
                        if (endIndex > 0 && endIndex > startIndex + 1)
                        {
                            faultMessage = serviceEx.Message.Substring(startIndex + 1, endIndex - startIndex - 1);
                        }
                        else
                        {
                            faultMessage = serviceEx.Message;
                        }
                    }
                }
            }
            return faultMessage;
        }
        #endregion

        #region 给上下文信息赋值
        /// <summary>
        /// 给上下文信息赋值
        /// </summary>
        /// <returns></returns>
        private static ThreadContext CreateContextObj(string OrgID)
        {
            // 实例化应用上下文对象
            ThreadContext thContext = new ThreadContext();


            System.Collections.Generic.Dictionary<object, object> ns = new Dictionary<object, object>();
            ns.Add("OrgID", OrgID);
            ns.Add("UserID", ConfigurationManager.AppSettings["userID"].ToString());
            ns.Add("UserCode", ConfigurationManager.AppSettings["userCode"].ToString());
            ns.Add("Datetime", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
            ns.Add("CultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            ns.Add("EnterpriseID", ConfigurationManager.AppSettings["enterpriseID"].ToString());
            ns.Add("DefaultCultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            ns.Add("acttype", ConfigurationManager.AppSettings["acttype"].ToString());
            thContext.nameValueHas = ns;

            return thContext;
        }
        #endregion
        public class ReturnValue1//List<rtnPoinfo>
        {
            public bool IsSuccess;
            public string Mes;
            public MessageBase[] poheadList;
        }
    }
}
